from openPoseFunctions import *
from os import listdir
from os.path import isfile, join

videoName='1979352.mp4'
#videoName='2410704.mp4'
#videoName='2726977.mp4'
videoFolder='../Vater'
openPoseFolder='../openPosePoints/'
outputFolder='../output/'
frameNumber=9
pointNumber=8

numberOfFrames=getNumberOfFrames(videoName, videoFolder)
lastFrame=numberOfFrames-1
#showAllPointsInImage(videoName, frameNumber, openPoseFolder, videoFolder)
bodypart='hand_right'
conf=getConfidence(videoName, frameNumber, bodypart, pointNumber, openPoseFolder)
print('conf: ', conf)
followPoint(videoName, bodypart, pointNumber, openPoseFolder, videoFolder)
########################################################################################################################
#find out if person uses left or right hand
########################################################################################################################

bodypart='hand_right'
pointRight=getPosition(videoName, frameNumber, bodypart, pointNumber, openPoseFolder)
print('x and y koordinate of right index finger: ', pointRight)
showPointInImage(videoName, frameNumber, pointRight, videoFolder)

bodypart='hand_left'
pointLeft=getPosition(videoName, frameNumber, bodypart, pointNumber, openPoseFolder)
print('x and y koordinate of left index finger: ', pointLeft)
showPointInImage(videoName, frameNumber, pointLeft, videoFolder)

xRight=pointRight[0]
yRight=pointRight[1]

xLeft=pointLeft[0]
yLeft=pointLeft[1]

if yLeft<yRight:
    print('Person uses left hand')
else:
    print('Person uses right hand')

########################################################################################################################
#find out if hand moves up or down
########################################################################################################################


if yLeft<yRight:
    bodypart='hand_left'
else:
    bodypart = 'hand_right'

firstFrame=0
pointStart=getPosition(videoName, firstFrame, bodypart, pointNumber, openPoseFolder)
showPointInImage(videoName, firstFrame, pointStart, videoFolder)

numberOfFrames=getNumberOfFrames(videoName, videoFolder)
lastFrame=numberOfFrames-1
pointEnd=getPosition(videoName, lastFrame, bodypart, pointNumber, openPoseFolder)
showPointInImage(videoName, lastFrame, pointEnd, videoFolder)

yStart=pointStart[1]
yEnd=pointEnd[1]
if yStart<yEnd:
    print('Hand moves down')
else:
    print('Hand moves up')

########################################################################################################################
#combine both for all videos in a folder
########################################################################################################################
upFile=open(outputFolder+'up.txt', 'w')
downFile=open(outputFolder+'/down.txt', 'w')

for videoName in sorted(listdir(videoFolder)):
    if isfile(join(videoFolder, videoName)) and videoName[0]!='.':
        print(videoName)

        bodypart = 'hand_right'
        pointRight = getPosition(videoName, frameNumber, bodypart, pointNumber, openPoseFolder)

        bodypart = 'hand_left'
        pointLeft = getPosition(videoName, frameNumber, bodypart, pointNumber, openPoseFolder)

        yRight = pointRight[1]
        yLeft = pointLeft[1]

        if yLeft < yRight:
            print('Person uses left hand')
            bodypart = 'hand_left'
        else:
            print('Person uses right hand')
            bodypart = 'hand_right'


        firstFrame = 0
        pointStart = getPosition(videoName, firstFrame, bodypart, pointNumber, openPoseFolder)

        numberOfFrames = getNumberOfFrames(videoName, videoFolder)
        lastFrame = numberOfFrames - 1
        pointEnd = getPosition(videoName, lastFrame, bodypart, pointNumber, openPoseFolder)

        yStart = pointStart[1]
        yEnd = pointEnd[1]
        if yStart < yEnd:
            print('Hand moves down')
            downFile.write(videoName+'\n')
        else:
            print('Hand moves up')
            upFile.write(videoName+'\n')

downFile.close()
upFile.close()


########################################################################################################################
#check distance between hands
########################################################################################################################
upFile=open(outputFolder+'up.txt', 'w')
downFile=open(outputFolder+'/down.txt', 'w')
unknownFile=open(outputFolder+'/unknown.txt', 'w')

for videoName in sorted(listdir(videoFolder)):
    if isfile(join(videoFolder, videoName)):
        print(videoName)

        bodypart = 'hand_right'
        pointRight = getPosition(videoName, frameNumber, bodypart, pointNumber, openPoseFolder)

        bodypart = 'hand_left'
        pointLeft = getPosition(videoName, frameNumber, bodypart, pointNumber, openPoseFolder)

        yRight = pointRight[1]
        yLeft = pointLeft[1]

        if yLeft < yRight:
            print('Person uses left hand')
            bodypart = 'hand_left'
        else:
            print('Person uses right hand')
            bodypart = 'hand_right'


        firstFrame = 0
        pointStart = getPosition(videoName, firstFrame, bodypart, pointNumber, openPoseFolder)

        numberOfFrames = getNumberOfFrames(videoName, videoFolder)
        lastFrame = numberOfFrames - 1
        pointEnd = getPosition(videoName, lastFrame, bodypart, pointNumber, openPoseFolder)

        yStart = pointStart[1]
        yEnd = pointEnd[1]
        distance=abs(yStart-yEnd)
        print('Distance: ', distance)
        if distance<20:
            print("not sure")
            unknownFile.write(videoName+'\n')
        else:
            if yStart < yEnd:
                print('Hand moves down')
                downFile.write(videoName+'\n')
            else:
                print('Hand moves up')
                upFile.write(videoName+'\n')

downFile.close()
upFile.close()
